package file.sr;
import java.io.IOException;
import java.net.DatagramSocket;
import java.net.Inet4Address;
import java.net.InetAddress;
import java.net.SocketException;
import java.util.Hashtable;
import java.util.concurrent.ConcurrentHashMap;

public class Sender {

	// bsico
	ArrayDePacotes listSender;
	DatagramSocket sender;

	// variaveis compartilhadas das threads
	public ConcurrentHashMap<Integer, Thread> tabela = new ConcurrentHashMap<Integer, Thread>();
	// tabela para guardar as threads de envio "ativas"

	public int sendBase = 0;
	public int nextSeqNum = 0;
	final int WINDOW_SIZE = 50;
	

	boolean iniciou = false;
	
	String fileName;
	int portaDoSender;
	int portaDoReceiver;
	InetAddress ipDoReceiver;

	public Sender(String fileName, int portaDoSender, int portaDoReceiver,
			InetAddress ipDoReceiver) throws IOException, InterruptedException {
		this.fileName = fileName;
		this.portaDoReceiver = portaDoReceiver;
		this.portaDoSender = portaDoSender;
		this.ipDoReceiver = ipDoReceiver;

		iniciar();
	}

	public void iniciar() throws IOException, InterruptedException {
		sender = new DatagramSocket(portaDoSender);
		listSender = new ArrayDePacotes(fileName);
		//listSender.criarArray();

		// System.out.println(contador);
	}

	public synchronized void addSendBase() {
		sendBase++;
	}

	public synchronized void addNextSeqNum() {
		nextSeqNum++;
	}
}
